package com.sa.ibiz.demo.demo.domain;

import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonProperty.Access;
import lombok.Data;
import org.springframework.beans.BeanUtils;
import org.springframework.cglib.beans.BeanMap;
import org.springframework.cglib.beans.BeanGenerator;
import com.baomidou.mybatisplus.annotation.TableLogic;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.FieldFill;
import java.util.Map;
import java.util.HashMap;
import org.springframework.util.StringUtils;
import com.sa.ibiz.demo.ibizutil.security.AuthenticationUser;
import java.util.Date;
import javax.validation.constraints.NotBlank;
import javax.validation.constraints.Size;
import org.springframework.util.DigestUtils;
import org.springframework.util.StringUtils;
import java.util.UUID;
import javax.validation.constraints.NotNull;
import java.io.Serializable;
import org.springframework.cglib.beans.BeanCopier;
import com.sa.ibiz.demo.ibizutil.annotation.Dict;
import com.sa.ibiz.demo.ibizutil.domain.EntityBase;
import java.io.Serializable;
import com.baomidou.mybatisplus.core.toolkit.IdWorker;
import java.math.BigInteger;
import com.sa.ibiz.demo.ibizutil.enums.FillMode;
import com.sa.ibiz.demo.ibizutil.enums.PredefinedType;
import com.sa.ibiz.demo.ibizutil.annotation.PreField;
import com.alibaba.fastjson.annotation.JSONField;

import com.sa.ibiz.demo.demo.domain.TSSDTask;

/**
 * 实体[TSSDTaskLog] 数据对象
 */
@TableName(value = "T_SRFTSSDTASKLOG",resultMap = "TSSDTaskLogResultMap")
@JsonIgnoreProperties(ignoreUnknown = true)
@Data
public class TSSDTaskLog extends EntityBase implements Serializable{

    @JSONField(serialize = false)
    @JsonIgnore
    @TableField(exist = false)//关系主表数据
    private TSSDTask tssdtask;
    @PreField(fill= FillMode.INSERT,preType = PredefinedType.CREATEDATE)
    private Timestamp createdate;
    @PreField(fill= FillMode.INSERT,preType = PredefinedType.CREATEMAN)
    @Dict(dictName = "ionicdemo_SysOperatorCodeList")
    private String createman;
    private Integer duration;
    private Timestamp endtime;
    private Integer retcode;
    private String retinfo;
    private Timestamp starttime;
    private String tssdtaskid;
    @TableId(value= "tssdtasklogid",type=IdType.UUID)//指定主键生成策略
    private String tssdtasklogid;
    private String tssdtasklogname;
    private String tssdtaskname;
    @PreField(fill= FillMode.INSERT_UPDATE,preType = PredefinedType.UPDATEDATE)
    private Timestamp updatedate;
    @PreField(fill= FillMode.INSERT_UPDATE,preType = PredefinedType.UPDATEMAN)
    @Dict(dictName = "ionicdemo_SysOperatorCodeList")
    private String updateman;
    /**
     *  设置属性值[建立时间]
     *  @param createdate
     */
    public void setCreatedate(Timestamp createdate){
        this.createdate = createdate;
        this.set("createdatedirtyflag",true);
    }
    /**
     *  获取属性值[建立时间]
     */
    public Timestamp getCreatedate(){
        return this.createdate;
    }
    /**
     *  重置属性值[建立时间]
     */
    public void resetCreatedate(){
        this.set("createdatedirtyflag",false);
        this.createdate = null;
    }
    /**
     *  设置属性值[建立人]
     *  @param createman
     */
    public void setCreateman(String createman){
        if(StringUtils.isEmpty(createman))
            createman=null;
        this.createman = createman;
        this.set("createmandirtyflag",true);
    }
    /**
     *  获取属性值[建立人]
     */
    public String getCreateman(){
        return this.createman;
    }
    /**
     *  重置属性值[建立人]
     */
    public void resetCreateman(){
        this.set("createmandirtyflag",false);
        this.createman = null;
    }
    /**
     *  设置属性值[持续时间]
     *  @param duration
     */
    public void setDuration(Integer duration){
        this.duration = duration;
        this.set("durationdirtyflag",true);
    }
    /**
     *  获取属性值[持续时间]
     */
    public Integer getDuration(){
        return this.duration;
    }
    /**
     *  重置属性值[持续时间]
     */
    public void resetDuration(){
        this.set("durationdirtyflag",false);
        this.duration = null;
    }
    /**
     *  设置属性值[结束时间]
     *  @param endtime
     */
    public void setEndtime(Timestamp endtime){
        this.endtime = endtime;
        this.set("endtimedirtyflag",true);
    }
    /**
     *  获取属性值[结束时间]
     */
    public Timestamp getEndtime(){
        return this.endtime;
    }
    /**
     *  重置属性值[结束时间]
     */
    public void resetEndtime(){
        this.set("endtimedirtyflag",false);
        this.endtime = null;
    }
    /**
     *  设置属性值[返回代码]
     *  @param retcode
     */
    public void setRetcode(Integer retcode){
        this.retcode = retcode;
        this.set("retcodedirtyflag",true);
    }
    /**
     *  获取属性值[返回代码]
     */
    public Integer getRetcode(){
        return this.retcode;
    }
    /**
     *  重置属性值[返回代码]
     */
    public void resetRetcode(){
        this.set("retcodedirtyflag",false);
        this.retcode = null;
    }
    /**
     *  设置属性值[返回信息]
     *  @param retinfo
     */
    public void setRetinfo(String retinfo){
        if(StringUtils.isEmpty(retinfo))
            retinfo=null;
        this.retinfo = retinfo;
        this.set("retinfodirtyflag",true);
    }
    /**
     *  获取属性值[返回信息]
     */
    public String getRetinfo(){
        return this.retinfo;
    }
    /**
     *  重置属性值[返回信息]
     */
    public void resetRetinfo(){
        this.set("retinfodirtyflag",false);
        this.retinfo = null;
    }
    /**
     *  设置属性值[开始时间]
     *  @param starttime
     */
    public void setStarttime(Timestamp starttime){
        this.starttime = starttime;
        this.set("starttimedirtyflag",true);
    }
    /**
     *  获取属性值[开始时间]
     */
    public Timestamp getStarttime(){
        return this.starttime;
    }
    /**
     *  重置属性值[开始时间]
     */
    public void resetStarttime(){
        this.set("starttimedirtyflag",false);
        this.starttime = null;
    }
    /**
     *  设置属性值[调度任务]
     *  @param tssdtaskid
     */
    public void setTssdtaskid(String tssdtaskid){
        if(StringUtils.isEmpty(tssdtaskid))
            tssdtaskid=null;
        this.tssdtaskid = tssdtaskid;
        this.set("tssdtaskiddirtyflag",true);
    }
    /**
     *  获取属性值[调度任务]
     */
    public String getTssdtaskid(){
        return this.tssdtaskid;
    }
    /**
     *  重置属性值[调度任务]
     */
    public void resetTssdtaskid(){
        this.set("tssdtaskiddirtyflag",false);
        this.tssdtaskid = null;
    }
    /**
     *  设置属性值[任务调度日志标识]
     *  @param tssdtasklogid
     */
    public void setTssdtasklogid(String tssdtasklogid){
        if(StringUtils.isEmpty(tssdtasklogid))
            tssdtasklogid=null;
        this.tssdtasklogid = tssdtasklogid;
        this.set("tssdtasklogiddirtyflag",true);
    }
    /**
     *  获取属性值[任务调度日志标识]
     */
    public String getTssdtasklogid(){
        return this.tssdtasklogid;
    }
    /**
     *  重置属性值[任务调度日志标识]
     */
    public void resetTssdtasklogid(){
        this.set("tssdtasklogiddirtyflag",false);
        this.tssdtasklogid = null;
    }
    /**
     *  设置属性值[任务调度日志名称]
     *  @param tssdtasklogname
     */
    public void setTssdtasklogname(String tssdtasklogname){
        if(StringUtils.isEmpty(tssdtasklogname))
            tssdtasklogname=null;
        this.tssdtasklogname = tssdtasklogname;
        this.set("tssdtasklognamedirtyflag",true);
    }
    /**
     *  获取属性值[任务调度日志名称]
     */
    public String getTssdtasklogname(){
        return this.tssdtasklogname;
    }
    /**
     *  重置属性值[任务调度日志名称]
     */
    public void resetTssdtasklogname(){
        this.set("tssdtasklognamedirtyflag",false);
        this.tssdtasklogname = null;
    }
    /**
     *  设置属性值[调度任务]
     *  @param tssdtaskname
     */
    public void setTssdtaskname(String tssdtaskname){
        if(StringUtils.isEmpty(tssdtaskname))
            tssdtaskname=null;
        this.tssdtaskname = tssdtaskname;
        this.set("tssdtasknamedirtyflag",true);
    }
    /**
     *  获取属性值[调度任务]
     */
    public String getTssdtaskname(){
        //填充物理化的外键值附加数据
        if(StringUtils.isEmpty(this.tssdtaskname)&&(!StringUtils.isEmpty(this.getTssdtaskid())) && this.getTssdtask()!=null)
        {
            this.tssdtaskname = this.getTssdtask().getTssdtaskname();
            this.set("tssdtasknamedirtyflag",true);
        }
        return this.tssdtaskname;
    }
    /**
     *  重置属性值[调度任务]
     */
    public void resetTssdtaskname(){
        this.set("tssdtasknamedirtyflag",false);
        this.tssdtaskname = null;
    }
    /**
     *  设置属性值[更新时间]
     *  @param updatedate
     */
    public void setUpdatedate(Timestamp updatedate){
        this.updatedate = updatedate;
        this.set("updatedatedirtyflag",true);
    }
    /**
     *  获取属性值[更新时间]
     */
    public Timestamp getUpdatedate(){
        return this.updatedate;
    }
    /**
     *  重置属性值[更新时间]
     */
    public void resetUpdatedate(){
        this.set("updatedatedirtyflag",false);
        this.updatedate = null;
    }
    /**
     *  设置属性值[更新人]
     *  @param updateman
     */
    public void setUpdateman(String updateman){
        if(StringUtils.isEmpty(updateman))
            updateman=null;
        this.updateman = updateman;
        this.set("updatemandirtyflag",true);
    }
    /**
     *  获取属性值[更新人]
     */
    public String getUpdateman(){
        return this.updateman;
    }
    /**
     *  重置属性值[更新人]
     */
    public void resetUpdateman(){
        this.set("updatemandirtyflag",false);
        this.updateman = null;
    }
     /**
     *  获取主实体关联数据[TSSDTask]
     */
    public TSSDTask getTssdtask() {
        return tssdtask;
    }
    /**
     *  设置主实体关联数据[TSSDTask]
     */
    public void setTssdtask(TSSDTask tssdtask) {
        this.tssdtask = tssdtask;
    }

    /**
     * 重置当前数据对象属性值
     */
    public  void reset(){
        resetCreatedate();
        resetCreateman();
        resetDuration();
        resetEndtime();
        resetRetcode();
        resetRetinfo();
        resetStarttime();
        resetTssdtaskid();
        resetTssdtasklogid();
        resetTssdtasklogname();
        resetTssdtaskname();
        resetUpdatedate();
        resetUpdateman();
    }
     /**
     * 获取数据主键（普通主键与联合主键）
     * @return
     */
    @JsonIgnore
    public Serializable getDefaultPrimaryKey()
    {
	    //随机生成主键
         return  IdWorker.get32UUID();

    }
     /**
     * 复制当前对象数据到目标对象(粘贴重置)
     *
     * @throws Exception
     */
    public TSSDTaskLog copyTo(TSSDTaskLog targetEntity)
	{
		BeanCopier copier=BeanCopier.create(TSSDTaskLog.class, TSSDTaskLog.class, false);
		copier.copy(this, targetEntity, null);
        targetEntity.resetTssdtasklogid();
		return targetEntity;
	}
}